class PeopleController < ApplicationController
	layout 'orders'
	before_filter :login_required

	def authorized?
		current_person.admin?
	end

	def index
		list
		render :action => 'list'
	end

	# GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
	verify :method => :post, :only => [ :destroy, :create, :update ],
               :redirect_to => { :action => :list }

	def list
		@people = Person.find(:all)
	end

	def show
		@person = Person.find(params[:id])
	end

	def new
		@person = Person.new
	end

	def create
		@person = Person.new(params[:person])
		if @person.save
			flash[:notice] = 'Person was successfully created.'
			redirect_to :action => 'list'
		else
			render :action => 'new'
		end
	end

	def edit
		@person = Person.find(params[:id])
	end

	def update
		@person = Person.find(params[:id])
		if @person.update_attributes(params[:person])
			flash[:notice] = 'Person was successfully updated.'
			redirect_to :action => 'show', :id => @person
		else
			render :action => 'edit'
		end
	end

	def destroy
		Person.find(params[:id]).destroy
		redirect_to :action => 'list'
	end
end
